package net.wanji.com.util;

import cn.hutool.core.util.HexUtil;
import freemarker.template.utility.StringUtil;

/**
 * @author duanruiming
 * @date 2023/06/20 15:07
 */
public class CommonUtils {

    /**
     * 将数组转化为16进制字符串
     * @param array
     * @return
     */
    public static String getHex4Array(int[] array) {
        StringBuilder sb = new StringBuilder();
        for (int i : array) {
            sb.append(i);
        }
        Integer binary = Integer.valueOf(sb.reverse().toString(), 2);
        return HexUtil.toHex(binary);
    }

    /**
     * 将时间转化为16进制 00：00 --> 061E0
     * @param time
     * @return
     */
    public static String getHourMinuteHex(String time) {
        StringBuffer sb = new StringBuffer();
        String[] split = time.split(":");
        String hour = String.format("%02x", Integer.valueOf(split[0]));
        String minute = String.format("%02x", Integer.valueOf(split[1]));
        return sb.append(hour).append(minute).toString();
    }

    public static String getBinary(Integer param) {
        int[] array = new int[64];
        array[param - 1] = 1;
        StringBuffer resultSb = new StringBuffer();
        for (int i = 0; i < array.length / 8; i++) {
            StringBuffer sb = new StringBuffer();
            for (int j = 0; j < 8; j++) {
                sb.append(array[i * 8 + j]);
            }
            String hex = String.format("%02x", Integer.parseInt(sb.reverse().toString(), 2));
            resultSb.insert(0, hex);
        }
        return StringUtil.leftPad(resultSb.toString(), 16, "0");
    }

    public static void main(String[] args) {
        System.err.println(getBinary(8));
    }
}
